From 015fa44ee4f357bce17d4bf3c2b22a6b8076bf36 Mon Sep 17 00:00:00 2001
From: Sergey Radionov <RSATom@gmail.com>
Date: Fri, 29 Jul 2011 19:41:06 +0700
Subject: [PATCH 2/3] NPAPI: Win32, Fullscreen window now created only when needed.

---
 projects/mozilla/vlc_win32_fullscreen.cpp |   19 ++++++++++++++++---
 1 files changed, 16 insertions(+), 3 deletions(-)

diff --git a/projects/mozilla/vlc_win32_fullscreen.cpp b/projects/mozilla/vlc_win32_fullscreen.cpp
index 7a2cce2..ffbe1e5 100644
--- a/projects/mozilla/vlc_win32_fullscreen.cpp
+++ b/projects/mozilla/vlc_win32_fullscreen.cpp
@@ -832,10 +832,14 @@ void VLCWindowsManager::CreateWindows(HWND hWindowedParentWnd)
 
 void VLCWindowsManager::DestroyWindows()
 {
-    _FSWnd->DestroyWindow();
+    if(_FSWnd){
+        _FSWnd->DestroyWindow();
+    }
     _FSWnd = 0;
 
-    _HolderWnd->DestroyWindow();
+    if(_HolderWnd){
+        _HolderWnd->DestroyWindow();
+    }
     _HolderWnd = 0;
 }
 
@@ -853,6 +857,10 @@ void VLCWindowsManager::LibVlcDetach()
 void VLCWindowsManager::StartFullScreen()
 {
     if(getMD()&&!IsFullScreen()){
+        if(!_FSWnd){
+            _FSWnd= VLCFullScreenWnd::CreateFSWindow(this);
+        }
+
         SetParent(_HolderWnd->getHWND(), _FSWnd->getHWND());
         SetWindowPos(_FSWnd->getHWND(), HWND_TOPMOST, 0, 0,
                      GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), 0/** /SWP_NOZORDER/**/);
@@ -873,7 +881,12 @@ void VLCWindowsManager::EndFullScreen()
 
         ShowWindow(_hWindowedParentWnd, SW_SHOW);
         ShowWindow(_FSWnd->getHWND(), SW_HIDE);
-    }
+
+        if(_FSWnd){
+            _FSWnd->DestroyWindow();
+        }
+        _FSWnd = 0;
+   }
 }
 
 void VLCWindowsManager::ToggleFullScreen()
-- 
1.7.4.msysgit.0

